Tajpi - Esperanto Keyboard

 Home Tajpi - Esperanto Keyboard
for Windows 2000 / XP / Vista / 7 / 8 / 10

In the Esperanto alphabet there are six diacritical letters which cannot be typed using standard keyboard layouts. Tajpi is a program that lets you type these letters with ease, without modifying your system in any way. "Tajpi" (pronounced "thai pea") means "to type" in Esperanto.

With Tajpi running on your computer you can:

- Keep using key combos like sx, gh, u^ etc - these will be automatically replaced by the correct Esperanto letter while you type.
- Remap your keyboard so that certain keys show Esperanto letters as soon as you type them.
- If your physical keyboard supports it, use Alt-Gr plus another key to enter Esperanto letters.
- Simulate the "dead key" input method that exists in some keyboard layouts.
- Script hotkeys that can be used to activate various functions, such as converting text to and from X-system or entering special Unicode characters.

Tajpi will make absolutely no changes to your system; it just sits in the background and responds to keyboard input. It is free software, published with its source code under the conditions of the GNU GPL version 3.

  • Installation
  • Configuration
  • Change history

© 2008- Thomas James Last updated 10-Jun-2016
tmj2005@gmail.com


Tajpi - Installation

 Home Tajpi - Esperanto Keyboard
Installing the program

1. Download and run the installer by either double clicking the icon or entering its name at the command line. The installer will appear as follows:

2. Click "Next" to begin the installation.
3. Accept the terms and conditions of the GPL license agreement and click "Next".
4. Enter the name of the directory into which Tajpi should be installed, or leave it as it is if you wish to install into C:\Program Files\Tajpi.
5. Click "Next".
6. Choose which icons should be put onto the Desktop and in the Quick Launch Bar.
7. Click "Install".

The program will then install and be ready for use. You can launch the program by selecting "Launch Tajpi" at the end of the installation process, or by double clicking Tajpi's icon at a later time.

  • ← Home
  • Configuration
  • Change history

© 2008- Thomas James Last updated 10-Jun-2016
tmj2005@gmail.com


Tajpi - Configuration

 Home Tajpi - Esperanto Keyboard
Configuring the program

This page contains instructions for configuring Tajpi. For information on TajpiScript please go here.

When Tajpi starts up for the first time it will ask you to configure it. The configuration window appears as follows:

  • Direct keys - When pressing a key from any of the six text boxes, the Esperanto letter printed above the text box will be displayed instead. This allows you to simulate a keyboard remap. If you want to input the the actual key rather than the Esperanto letter you can hold down Alt Gr (or Ctrl+Alt) while you press the key.
  • Prefixes - Typing c, g, h, j, s or u immediately after a prefix symbol will make the letter appear with a diacritic.
  • Make prefix character invisible - Prefix characters will not appear when typed in. To make a prefix character appear you can type either a space or any other character (except c, g, h, j, s or u) after it. This simulates the behaviour of the so-called "dead keys" which exist in some standard keyboard layouts.
  • Suffixes - When one of the configured suffix characters is entered immediately after c, g, h, j, s or u, the letter will receive a diacritic. By default the suffixes box contains an H, however speakers of some languages (English for example) may wish to remove this so that diacritics won't appear when typing "ch", "sh" etc.
  • Repeat of suffix removes diacritic - Press the suffix key again to remove the diacritic.
  • Alt Gr + letter to receive diacritic - Pressing Alt Gr (or Ctrl+Alt) together with either c, g, h, j, s or u will make the letter appear with a diacritic. For example Alt Gr+C would make ĉ appear.
  • Automatic aŭ/eŭ - A u typed after a or e will appear as ŭ.
  • w for ŭ - The letter w is pressed instead of u to show ŭ. This is useful if there is a conflict with the system keymap's method for adding a diacritic to u.
  • Unicode / Latin-3 - Lets you choose between Unicode and Latin-3 character sets. Unicode is recommended, but Latin-3 support is included for those who wish to continue using their old Latin-3 fonts or applications that don't fully support Unicode.
  • Paste letter out of clipboard - When selected Tajpi will not input the diacritical letter directly to the system, but will instead copy it to the clipboard and paste it out.

    Next to this option is a button which you can click on to show the following window, which allows you to configure the keystroke Tajpi will use when pasting the letter:
    It is recommended to use Shift+Insert but Ctrl+V is provided as an alternative and should generally work just as well.

    Putting the letter in the clipboard will delete whatever was previously stored there, however it is possible to restore the contents of the clipboard with the option "Restore clipboard contents after paste". When selected, the contents of the clipboard will be automatically restored after the number of milliseconds as specified in the "After ... milliseconds" text box. Please note that this only works for text. Files, pictures and other data types are not supported.
  • HTML entity codes - Tajpi will input HTML entity codes instead of diacritical letters. For example &#265; instead of ĉ. Web developers in particular may find this feature useful.
  • Start active - When Tajpi starts it will be in active mode.
  • Automatic start - Tajpi will automatically start up along with Windows
  • Hotkey - Configuration for the hotkey which activates / deactivates Tajpi.
  • Language - You can click on the flags Esperanto Flag and English Flag to switch the interface language between Esperanto and English.
  • Installation
  • ← Home
  • Change history

© 2008- Thomas James Last updated 10-Jun-2016
tmj2005@gmail.com


Tajpi - Script

 Home Tajpi - Esperanto Keyboard
Scripting the program

Tajpi Script provides advanced configuration and text conversion/input utilities. It uses a simple syntax to configure hotkeys which can be activated at any time from the keyboard. The script file is called Tajpi.skr and resides in the Tajpi program folder, which by default is C:\Program Files (x86)\Tajpi.

In the following example, the hotkey Ctrl+R is configured to activate/deactivate Russian transliteration. The caret sign [^] stands for the Ctrl key, which is known as a modifier:

^R::rusa

To use more than one modifier with a hotkey, list them consecutively (the order doesn't matter). The following example uses ^!S to indicate Ctrl+Alt+S, and activates cyrillic transliteration:

^!S::cirila

You can use the following modifier symbols to define hotkeys:

Symbol | Description
! | Alt
^ | Control
+ | Shift
< | Use the left key of the pair. e.g. <!a is the same as !a except that only the left Alt key will trigger it.
> | Use the right key of the pair.

It is possible to completely leave out modifiers from a hotkey and just bind to a single key. For example the following hotkey will show the configuration window when pressing F12:

F12::agordi

Tajpi Script is case insensitive. The following hotkey pairs have exactly the same effect:

^+a::agordi
^+A::AGORDI
>!sPaCe::cIRIla
>!SpAcE::CiriLA

Anything after a semicolon is treated as a comment, and will be ignored:

;this is a comment
^+insert::rusa  ;this hotkey is active
;^+space::rusa   and this one is not

The name of the key to bind to should be spelt according to the drop down list at the bottom of the Tajpi configuration window (spaces may be left out however). When amending a script remember to save it and restart Tajpi.

The following commands may be used in your hotkeys:

Command | Description
cirila Activates/deactivates Cirilic transliteration. When an Esperanto letter is typed, it will automatically appear as the most phonetically equivalent letter from the Cirilic alphabet. The following scheme is used:
a а | b б | c ц | ĉ ч | d д | e е | f ф | g г | ĝ ѓ | h х | ĥ ћ | i и | j й | ĵ ж | k к | l л | m м | n н | o о | p п | r р | s с | ŝ ш | t т | u у | ŭ ў | v в | z з
A А | B Б | C Ц | Ĉ Ч | D Д | E Е | F Ф | G Г | Ĝ Ѓ | H Х | Ĥ Ћ | I И | J Й | Ĵ Ж | K К | L Л | M М | N Н | O О | P П | R Р | S С | Ŝ Ш | T Т | U У | Ŭ Ў | V В | Z З
rusa Activates/deactivates Russian transliteration. When an Esperanto letter is typed, it will automatically appear as the most phonetically equivalent letter (or combination of letters) from the Russian alphabet. The following scheme is used, with the differences to the Cirilic scheme shown in red:
a а | b б | c ц | ĉ ч | d д | e е | f ф | g г | ĝ дж | h х | ĥ х | i и | j й | ĵ ж | k к | l л | m м | n н | o о | p п | r р | s с | ŝ ш | t т | u у | ŭ у | v в | z з
A А | B Б | C Ц | Ĉ Ч | D Д | E Е | F Ф | G Г | Ĝ ДЖ | H Х | Ĥ Х | I И | J Й | Ĵ Ж | K К | L Л | M М | N Н | O О | P П | R Р | S С | Ŝ Ш | T Т | U У | Ŭ У | V В | Z З
ssigi_elektitan | Converts the currently selected text from X-system to diacritical Esperanto letters. Can be used in a text box or any text editor program such as Word or Notepad.
ssigi_tondujon | Converts text held in the clipboard from X-system to diacritical Esperanto letters.
xigi_elektitan | Converts any diacritical Esperanto letters in the currently selected text to X-system.
xigi_tondujon | Converts any diacritical Esperanto letters in the text held in the clipboard to X-system.
higi_elektitan | Converts any diacritical Esperanto letters in the currently selected text to H-system.
higi_tondujon | Converts any diacritical Esperanto letters in the text held in the clipboard to H-system.
htmligi_elektitan | Converts all symbols in the currently selected text to HTML entity codes. This can also be useful for determining the Unicode code-point value of a particular symbol, or series of symbols.
htmligi_tondujon | Converts all symbols in the text held in the clipboard to HTML entity codes.
### The command may be a numerical value representing any Unicode symbol to be input to the system. The following hotkey inputs Ĉ upon pressing Ctrl+Alt+C:
^!C::264
It is possible to specify a hexadecimal value by prepending with "&H". The following hotkey sends the ♥ symbol:
^!H::&H2665
You can also send multiple symbols with one hotkey by delimiting the codes with a comma. The following sends AAA:
^!A::65,65,65
See here for a complete list of Unicode symbols.
_[text] The command may be a peice of literal text to be input to the system, which must be prefixed with an underscore. The following hotkey inputs eĥoŝanĝo ĉiuĵaŭde when pressing Alt+E:
!E::_eĥoŝanĝo ĉiuĵaŭde
Escape sequences may be used: \n for newline and \t for tab. Backslashes and semicolons must be escaped with a backslash in front of them.
agordi | Shows the Tajpi configuration window.
alglui | Toggles the option "Paste out of clipboard" in the configuration window.
english | Changes the interface language to English.
esperanto | Changes the interface language to Esperanto.
eliri | Quits Tajpi.
helpo | Shows the help file in the current interface language.
helpo_en | Shows the English help file.
helpo_eo | Shows the Esperanto help file.
html | Toggles the option "HTML entity codes" in the configuration window.
klavkomando | Activates/deactivates Tajpi. A hotkey for this is already present in the Tajpi configuration window, however you can add others with this command.
latina3 | Sets the option "Latin-3" in the configuration window.
pri_tajpi | Shows the "About Tajpi" window.
skripto | Toggles TajpiScript on and off. Only this command will be recognized when TajpiScript is disabled.
unikodo | Sets the option "Unicode" in the configuration window.

After editing the script you must save the script file and restart Tajpi. Note that TajpiScript recognizes ASCII and UTF-8 file formats only. Unicode formats other than UTF-8 are not supported.

  • ← Configuration

© 2008- Thomas James Last updated 10-Jun-2016
tmj2005@gmail.com


Tajpi - History

 Home Tajpi - Esperanto Keyboard
Change history

2.98 (10-Jun-16):
  • Updated various bits of information in the website, program and supporting files.
2.97 (26-Feb-12):
  • Added option "w por ŭ".
  • Slightly modified the transliteration scheme for Russian/Cirilic letters. To see the new scheme, check the instructions for TajpiScript.
  • Made some additions and corrections in the help files.
2.96 (15-Aug-11):
  • Removed the Win key from the list of modifier keys in TajpiScript.
2.95 (14-Aug-11):
  • Added "htmligi_elektitan" and "htmligi_tondujon" commands to TajpiScript.
2.94 (12-Aug-11):
  • TajpiScript now allows input of literal strings.
  • Added "skripto" command to TajpiScript, which toggles TajpiScript on and off.
  • Fixed a bug which caused a problem when processing script files saved in ANSI format.
2.93 (10-Aug-11):
  • TajpiScript now allows multiple Unicode symbols to be specified in one hotkey by delimiting with a comma.
  • Fixed a bug in TajpiScript which disabled some Win-key shortcuts in Windows.
  • Corrected a mistake in the Esperanto TajpiScript help file. Command "halti" now reads "eliri".
2.92 (08-Aug-11):
  • Fixed a bug in TajpiScript, whereby pressing the Win key would still show the start menu even if it been bound to a hotkey.
2.91 (07-Aug-11):
  • Added "Tajpi Script" feature. See configuration help page for usage instructions.
  • Transliteration of Russian / Cyrillic letters is now handled by Tajpi Script and is disabled by default. To activate it, uncomment the appropriate lines in Tajpi.skr in the Tajpi folder and configure your preferred keystroke.
  • Ctrl+Alt can now be used as an alternative to Alt Gr on keyboards that don't have that key.
  • Cleaned up HTML in help files and corrected several typos.
  • Corrected some text in the Tajpi interface.
  • Fixed a small bug in the activation/deactivation hotkey.
  • Some source code cleanup.
2.90 (13-Apr-11):
  • Corrected spelling error on configuration window: "Automata aŭ/eŭ" to "Aŭtomata aŭ/eŭ".
2.89 (08-Apr-11):
  • Fixed a small bug which caused the option "Repeat of suffix removes diacritic" to work incorrectly in some circumstances.
2.88 (07-Apr-11):
  • Fixed a huge bug which caused accents to appear in some multithreaded applications, even when a keyboard layout was being used that does not contain accentable Esperanto letters. Thanks to Valentin Melnikov for reporting and assisting in fixing this bug.
  • Fixed a bug which would sometimes cause the taskbar menu to be shown on top of the Tajpi menu, when right clicking the system tray icon.
  • Fixed a bug which sometimes stopped the option "Repeat of suffix gets rid of accent" from working correctly.
  • Reversed the sound effects for enable/disable of the program.
  • Added an icon for Tajpi in "Add/Remove Programs".
  • Added further support for complex dead-key composite combinations.
  • Large clean up of source code.
2.87 (23-Mar-11):
  • Fixed a bug introduced in a previous version which made it impossible to type a non-alpha character into certain fields in the configuration window.
2.86 (23-Mar-11):
  • Added the ability to easily input a character that is configured as a direct key, by way of Alt Gr.
  • The option "Alt Gr + letter to receive diacritic" is now fully compatible with "Paste letter out of clipboard".
  • Fixed a small bug which caused the milliseconds textbox in the "Paste Method" window to be uneditable even when the option "Restore clipboard contents after paste" was selected.
2.85 (22-Mar-11):
  • Fixed a long standing bug which caused accents to sometimes not appear when the option "Paste out of clipboard" was selected together with the sub option Ctrl+V.
  • Russian/Cyrillic transliteration now deactivates when the program is enabled/disabled.
  • The option "Restore clipboard after paste" is now selected by default.
  • Fixed a bug which prevented deletion of a direct key from the configuration window, when Caps Lock was active.
  • Cleaned up source code.
2.84 (20-Mar-11):
  • Fixed a bug which caused non-alpha direct keys to function incorrectly if Shift was pressed or Caps Lock enabled.
2.83 (18-Mar-11):
  • Fixed a bug which caused Tajpi to sometimes remain running in the background after quitting the program.
  • Fixed an error message in the installer which would appear if the program was already running due to the above bug.
  • Fixed a small issue which would sometimes cause an accented character not to appear if Alt Gr had just been used to accent some other character.
2.82 (18-Mar-11):
  • Fixed a bug which caused a conflict with the dead keys in some keyboard layouts.
2.81 (17-Mar-11):
  • Fixed a bug which caused Latin-3 characters to only be correctly inserted if the option "Paste out of Clipboard" was selected.
  • Changed activation method for Russian/Cirilic transliteration to make it less accidentally triggerable. Key press is now Right Ctrl 3 times followed by Numpad 7 for Russian, or Numpad 8 for Cirilic.
2.80 (01-Sep-09):
  • Simplified and updated the help files.
2.79 (26-Aug-09):
  • Fixed a bug which caused a conflict with the Shift key on certain computers.
2.78 (19-Aug-09):
  • Fixed a bug which caused the program to function incorrectly in Windows 7.
2.77 (07-Aug-09):
  • Fixed a bug which caused problems with the Shift key in Windows Vista.
  • Fixed a small bug in the "About Tajpi" window which caused Esperanto text to appear without accents.
2.76 (06-Aug-09):
  • Fixed a bug which caused the "Repeat of suffix gets rid of accent" option to work incorrectly in Windows Vista.
2.75 (04-Aug-09):
  • Added the ability to change the language of the interface, and help file. It is now possible to select between Esperanto and English by clicking on the icons in the configuration window.
  • Added the text "Aktiva" to the tooltip of the tray icon. In active mode, the tooltip appeared as "Tajpi". It now reads as "Tajpi - Aktiva".
  • Fixed a few small bugs.
  • General cleanup of source code.
  • Updated the help files.
2.74 (25-Jul-09):
  • Fixed a bug which caused an error box to appear when closing the program, with the message "Run-time error '424': Object required."
2.73 (24-Jul-09):
  • Fixed a bug which caused the "Paste Method" window to crash the program when it appeared, on certain computers.
2.72 (23-Jul-09):
  • Fixed a nasty bug when caused the program to crash upon startup leaving the icon in the system tray, which would disappear upon hovering over it with the mouse.
  • A few corrections to Esperanto text in the program interface.
  • Updated the help files.
2.71 (23-Jun-09):
  • A few updates / corrections to text in the program and help files.
  • Changed the default state of the "Start automatically" option. It is now selected by default.
  • Added an option to start up Tajpi upon completion of the installation process.
2.7 (23-Jun-09):
  • Several corrections to text in the program interface and help files.
  • Added the ability to specify the method Tajpi uses when pasting the accented letter out of the clipboard, and the ability to restore the clipboard contents after the paste.
  • Tajpi now makes a beep when enabled / disabled.
  • Fixed a bug which caused the program to close when the configuration window was closed by the menu in the window's top left corner icon, or by some other means such as a reprogrammed mouse button.
  • The installer / uninstaller will now close Tajpi if it is already running. This ensures that the files can be properly deleted / overwritten in the installation / uninstallation process.
  • Changed the behaviour of the "Repeat of suffix gets rid of accent" option. Now you have to press the same suffix key as the one that was used to accent the letter.
  • Added Alt+key shortcuts to various controls of the configuration window, which had been accidentally left out.
  • Big cleanup and reordering of the source code.
  • Updated the help files.
2.68 (11-Jun-09):
  • Changed the input method of the secret keypresses again. Before you had to press LShift+RShift+key. But since that hinders one-handed users the new method is to press Ctrl 5 times (either left or right) and then press the key. So 5 x Ctrl and then R to switch to Russian cirilic letters.
  • Cleaned up the source code a bit.
  • Updated the help files.
2.67 (11-Jun-09):
  • Changed the secret keypresses method back to how it was before version 2.66.
2.66 (11-Jun-09):
  • Fixed a bug which caused the program to close if the configuration window was closed by double clicking the icon in the top left corner.
  • Added more "secret keypresses". Press Shift twice and then S to show them.
2.65 (09-Jun-09):
  • Fixed a bug which caused general problems with the "Repeat of suffix gets rid of accent" option.
  • Updated the help files.
2.64 (04-Jun-09):
  • When Tajpi starts up, if the program is already running it will be closed and the new process will replace it. This ensures there will only ever be one running instance of the program.
  • Corrected the text in the configuration window "Latin-3" to "Latina-3" for the Esperanto interface.
  • Updated the help files.
  • From this version onwards Tajpi is now published with its source code under the conditions of the GNU GPL version 3 or any later version.
2.63 (18-May-09):
  • Fixed a bug accidentally introduced in version 2.62, concerning the cirilic transliterations of the Esperanto accented letters.
2.62 (17-May-09):
  • Fixed a few small bugs and general cleanup of source code.
2.61 (16-May-09):
  • Fixed a strange bug, apparently introduced in some previous version, which caused the "Repeat of suffix gets rid of accent" option to be totally ignored.
2.6 (15-May-09):
  • Added the ability to enter accented letters by way of the Alt Gr key. You can now press for example Alt G+C to enter ĉ.
2.5 (13-May-09):
  • Changed the keypress method for the hotkey that enables / disables the program.
  • Corrected a bug which caused incorrect HTML entity codes to appear when typing in transliterated cirilic letters.
  • Added a further input method for transliterated letters. Now you can press LShift+RShift+R for cirilic letters out of the Russian alphabet only.
2.41 (11-May-09):
  • Tajpi now recognizes Windows "dead keys" as prefixes for accented Esperanto letters. If the accentable letter belongs to both the Esperanto alphabet and the current system keymap, the Esperanto letter will take priority.
2.4 (09-May-09):
  • Added the ability to type in transliterated cirilic letters. To enable / disable this, press LShift+RShift+C.
2.3 (08-May-09):
  • Added the "Make the prefix letter invisible" option.
  • Fixed a small bug, which caused the text boxes for the direct keys to fail to convert the entered letter to uppercase.
2.23 (07-May-09):
  • Fixed a bug which caused accented letters to appear even when the user had a system keymap that doesn't even contain the letters c, g, h, j, s or u.
  • Changed the automatic keystroke to paste the letter out of the clipboard. Shift+Insert is now used instead as Ctrl+V appears to cause some problems in a few non European keymaps.
2.22 (07-May-09):
  • Recompiled the help files to a single .chm file.
2.21 (07-May-09):
  • Fixed another bug with the dead keys. Now it is possible to type a dead key + Space to show the dead key letter.
2.2 (06-May-09):
  • Fixed a nasty bug which caused a conflict with the "dead keys" which exist in some Windows keymaps, such as German, Brazilian etc.
  • Corrected text in the tooltip of the Quick Launch Bar icon. Before it read "My Program". Changed to "Tajpi".
2.1 (04-May-09):
  • A few corrections to spelling/translation errors in the interface text.
  • Improved the installer with options to put icons on the Desktop and Quick Launch Bar, and automatically delete the configuration file and registry keys which were previously being left behind in the uninstall.
2.0 (01-May-09):
  • Completely rewrote Tajpi in VB6, and added a new interface which more or less follows Ek, with general simplification.
  • Now only compatible with Windows 2000, XP, Vista and 7. Tajpi does not support Win9x, ME or NT.
  • Added the "Direct keys" option.
  • Made "Repeat of suffix gets rid of accent" optional.
  • Added the "Automatic aŭ/eŭ" option.
  • Added the option to enter accented letters by either direct input or by pasting it out of the clipboard.
  • Added the "Automatic start" option. This works by way of a registry key in HKEY_CURRENT_USER \ Software \ Microsoft \ Windows \ CurrentVersion \ Run \ Tajpi.
  • Added the "Hotkey" to activate/deactivate the program.
  • Created an installer for the program with Inno Setup. The product is now a self extracting .exe file which installs the program and puts icons in the start menu and on the Desktop.
1.0 (08-Aug-08):
  • First version of Tajpi, built with AutoHotkey. This program and its change history are no longer available.
  • Installation
  • Configuration
  • ← Home

© 2008- Thomas James Last updated 10-Jun-2016
tmj2005@gmail.com